EXT_WIDTH=0.8+0.01;
ADD_SUPPORT=0;

Indetation=0; /* 0= Turn off Top case identation to print easier. */
dipSwitchAccess= 1; /* 1= Turn on Top case Dip access */
indentationRAMSocket= 1; /* 1= Turn Top case indentation if RAM is socketed */
romAccess=0; /* 1= Acces to ROM on the Top. */

/* measured line thickness */

/*
BACK_CLIP_THICK=1.2;
SCREW_HOLE_THICK=1.9;
TOP_STICK_R=1;
TOP_MID_BAR_THICK=1.2;
FRONT_BAR_THICK=1.5;
SIDE_THICK=2.2;
SIDE_THIN=1.2;
FRONT_CLIP_THICK=1.5;
PCB_SUPPORT_THICK=1.9;
PCB_BLOCK_THICK=1.6;
TETRIS_THICK=1.5;
CLIP_HOLDER_THICK=2.5;
CLIP_HOLDER_PROT_W=0.9;
CLIP_HOLDER_SIDE_THICK=1.6;
CLIP_HOLDER_HOLE_DEPTH=1.9;
BOTTOM_THICK=2;
BACK_CLIP_PROT_W=BACK_CLIP_THICK+1.1;
BACK_CLIP_HEIGHT=12.2;
FRONT_CLIP_PROT=1;
FRONT_CLIP_HEIGHT=12.3;
*/

/* adjusted for printing */

BACK_CLIP_THICK=2*EXT_WIDTH;
SCREW_HOLE_THICK=3*EXT_WIDTH;
TOP_STICK_R=EXT_WIDTH;
TOP_MID_BAR_THICK=2*EXT_WIDTH;
FRONT_BAR_THICK=2*EXT_WIDTH;
SIDE_THICK=3*EXT_WIDTH;
SIDE_THIN=2*EXT_WIDTH;
FRONT_CLIP_THICK=2*EXT_WIDTH;
PCB_SUPPORT_THICK=2*EXT_WIDTH;
PCB_BLOCK_THICK=2*EXT_WIDTH;
TETRIS_THICK=2*EXT_WIDTH;
CLIP_HOLDER_THICK=3*EXT_WIDTH;
CLIP_HOLDER_PROT_W=EXT_WIDTH;
CLIP_HOLDER_SIDE_THICK=2*EXT_WIDTH;
CLIP_HOLDER_HOLE_DEPTH=2*EXT_WIDTH;
BOTTOM_THICK=2.6;
BACK_CLIP_PROT_W=BACK_CLIP_THICK+1.6;
BACK_CLIP_HEIGHT=11.9;
FRONT_CLIP_PROT=1.4;
FRONT_CLIP_HEIGHT=11.6;

/* other measurements */

PCB_THICK=1.6;
PCB_SUPPORT_HEIGHT=4.2;

SCREW_HOLE_R=1.4;
SCREW_HOLE_BODY_R=SCREW_HOLE_R+SCREW_HOLE_THICK;

WIDTH=140;
DEPTH=80;
DEPTH_TURN=30;
WIDTH_TURN=1.5;
HEIGHT=6.5;
R_CORNER=2;
R_CORNER_SMALL=1;

TOP_HEIGHT=2;
TOP_APEX_WIDTH=2.2;
EDGE_WIDTH_X=2; /* Frank less angled for better print was 3.5 */
EDGE_WIDTH_Y1=3; /* Frank less angled for better print was 7.5 */
EDGE_WIDTH_Y2=3; /* Frank less angled for better print was 3.5 */

TOP_HOLE_DEPTH=1;
TOP_THICK=2.7;

SIDE_PROTRUSION_TOP=1.5;
SIDE_PROTRUSION_BOTTOM=2;

BACK_HOLE_WIDTH_TOP=54;
BACK_HOLE_OPENING_TOP=2;
BACK_HOLE_WIDTH_BOTTOM=54.7;
BACK_HOLE_HEIGHT_BOTTOM=5.5;

FRONT_HOLE_WIDTH_TOP=114;
FRONT_HOLE_HEIGHT_TOP=3.5;
FRONT_HOLE_OPENING_TOP=5;

FRONT_HOLE_WIDTH_BOTTOM=114;
FRONT_HOLE_WIDTH_BOTTOM_SMALL=109;
FRONT_HOLE_DEPTH_BOTTOM=8.5;

BACK_CLIP_DEPTH=3.7;
BACK_CLIP_Y=5.8;
BACK_CLIP_DIST=95.7;
BACK_CLIP_WIDTH=8;
BACK_CLIP_PROT_H=2;
BACK_CLIP_SUPPORT=7;

FRONT_CLIP_WIDTH=6;
FRONT_CLIP_PROT_H=3;
FRONT_CLIP_PROT_Z=6.9;

TOP_FRONT_BAR_LENGTH=120;

TOP_MID_BAR_HEIGHT=2.5;

BOTTOM_FRONT_BAR_LENGTH=114;
BOTTOM_FRONT_BAR_HEIGHT=3;
BOTTOM_FRONT_BAR_ROUNDRECT=10.6+2.25; /* Frank */

FRONT_BAR_Y=9.5;

TOP_STICK_Y=7;
TOP_STICK_DIST=61.5;

CLIP_HOLDER_WIDTH=12.5;
CLIP_HOLDER_HEIGHT=8.7;
CLIP_HOLDER_PROT_H=1.6;
CLIP_HOLDER_Y=6.5;
CLIP_HOLDER_HOLE_WIDTH=CLIP_HOLDER_WIDTH-2*CLIP_HOLDER_SIDE_THICK;

PCB_SUPPORT_PROT=0.4;
PCB_SUPPORT_R_OUTER=5;
PCB_SUPPORT_R_HOLE=1.7;
PCB_SUPPORT_R_INNER=PCB_SUPPORT_R_HOLE+PCB_SUPPORT_THICK;
PCB_SUPPORT_R_UNDER=4.3;
PCB_SUPPORT_HEIGHT_UNDER=2.4;

TOP_FRONT_BAR_HEIGHT=2*HEIGHT+2*TOP_HEIGHT-PCB_SUPPORT_HEIGHT-PCB_THICK;
SCREW_HOLE_HEIGHT=TOP_FRONT_BAR_HEIGHT;
TOP_PROTRUSION=TOP_FRONT_BAR_HEIGHT-HEIGHT-TOP_HEIGHT;

PCB_BLOCK_DIST=75.7;
PCB_BLOCK_HEIGHT=7;
PCB_BLOCK_WIDTH=7;
PCB_BLOCK_DEPTH_LOW=6.3;
PCB_BLOCK_DEPTH_HIGH=5.3;
PCB_BLOCK_Y=18; /* Frank old value 34.5;*/ 

TETRIS_HEIGHT=HEIGHT+TOP_HEIGHT;
TETRIS_HEIGHT2=4;
TETRIS_DEPTH=3.8;
TETRIS_DIST=59.5;

module body_halve(h, x, y1, y2) {
    linear_extrude(height=h,convexity=10)
        polygon(points=[[0,y1],[0,DEPTH-y2],[WIDTH/2-x,DEPTH-y2],[WIDTH/2-x,DEPTH_TURN],[WIDTH/2-WIDTH_TURN-x,y1]]);
}

module body_round(h, x, y1, y2, r) {
    minkowski() {
        body_halve(h, r+x,r+y1,r+y2);
        cylinder(0.01,r=r, $fn=20);
    }
}

module body_hull() {
    intersection() {
        hull() {
            body_halve(0.01, 0,0,0);
            translate([0,0,TOP_HEIGHT])
                body_halve(0.01, EDGE_WIDTH_X, EDGE_WIDTH_Y1, EDGE_WIDTH_Y2);
        }
        body_round(TOP_HEIGHT,0,0,0,R_CORNER);
    }
}

module body_help(thick) {
    union() {
        difference() {
            body_round(HEIGHT,0,0,0,R_CORNER);
            translate([0,0,HEIGHT-thick-0.01])
            intersection() {
                body_hull();
                body_halve(HEIGHT-thick,SIDE_THICK,SIDE_THICK,SIDE_THICK);
            } 
            body_halve(HEIGHT-thick,SIDE_THICK,SIDE_THICK,SIDE_THICK);
        }
    }
}

module upper_support() {
    for( i = [0:(WIDTH-80)/8] )
        translate([i*4+2,0,HEIGHT])
            cube([EXT_WIDTH, DEPTH, TOP_HEIGHT]);

    intersection() {
        for( i = [0:DEPTH/4] )
            translate([0,i*4+2,HEIGHT])
                cube([WIDTH/2, EXT_WIDTH, TOP_HEIGHT]);

        translate([0,0,HEIGHT+TOP_HEIGHT-TOP_HOLE_DEPTH+0.02])
            body_halve(TOP_HOLE_DEPTH,TOP_APEX_WIDTH+EDGE_WIDTH_X,TOP_APEX_WIDTH+EDGE_WIDTH_Y1,TOP_APEX_WIDTH+EDGE_WIDTH_Y2);
    }
}

module body_upper_hole() {
    translate([BACK_CLIP_DIST/2,DEPTH-BACK_CLIP_DEPTH-BACK_CLIP_Y,0])
        cube([BACK_CLIP_WIDTH,BACK_CLIP_DEPTH,100]);
}

module body_upper_top() {
    difference() {
        translate([0,0,HEIGHT])
            body_hull();
        translate([0,0,HEIGHT+TOP_HEIGHT-TOP_HOLE_DEPTH+0.02])
        if(Indetation==1){ /* Frank */
            body_halve(TOP_HOLE_DEPTH,TOP_APEX_WIDTH+EDGE_WIDTH_X,TOP_APEX_WIDTH+EDGE_WIDTH_Y1,TOP_APEX_WIDTH+EDGE_WIDTH_Y2);
        }    
        body_upper_hole();
    }
}

module body_upper_rest() {
    difference() {

    intersection() {
        union() {
            difference() {
                body_help(TOP_THICK);
                body_upper_hole();
            }
            top_protrusion();
            translate([0,DEPTH-SIDE_THICK,-TOP_PROTRUSION])
                cube([BACK_HOLE_WIDTH_TOP/2,SIDE_THICK,TOP_PROTRUSION]);
            translate([BACK_CLIP_DIST/2,DEPTH-BACK_CLIP_Y+BACK_CLIP_THICK,HEIGHT+TOP_HEIGHT])
            rotate([0,0,90]) {
                translate([0,0,-TOP_HEIGHT])
                    top_clip(BACK_CLIP_WIDTH, BACK_CLIP_HEIGHT-TOP_HEIGHT);
                translate([0,-BACK_CLIP_WIDTH/2-BACK_CLIP_THICK/2,-BACK_CLIP_HEIGHT+BACK_CLIP_SUPPORT])
                    cube([BACK_CLIP_Y-SIDE_THICK-BACK_CLIP_THICK,BACK_CLIP_THICK,BACK_CLIP_HEIGHT-BACK_CLIP_SUPPORT-TOP_HEIGHT]);
            }
            translate([BACK_CLIP_THICK+TOP_FRONT_BAR_LENGTH/2,FRONT_CLIP_WIDTH+SIDE_THICK, HEIGHT])
                top_clip(FRONT_CLIP_WIDTH,FRONT_CLIP_HEIGHT-TOP_HEIGHT);

            if(Indetation==1){ /* Frank */
                translate([-TOP_MID_BAR_THICK/2,0,HEIGHT+TOP_HEIGHT-TOP_THICK-TOP_MID_BAR_HEIGHT+0.01])
                    cube([TOP_MID_BAR_THICK,DEPTH,TOP_MID_BAR_HEIGHT]);
            }
            translate([0,DEPTH/2,HEIGHT])
            mirror([0,0,1])
            difference() {
                cylinder(SCREW_HOLE_HEIGHT-TOP_HEIGHT,r=SCREW_HOLE_BODY_R,$fn=30);
                cylinder(SCREW_HOLE_HEIGHT-TOP_HEIGHT,r=SCREW_HOLE_R,$fn=30);
            }
            translate([0,FRONT_BAR_Y,HEIGHT])
            mirror([0,0,1])
                cube([TOP_FRONT_BAR_LENGTH/2,FRONT_BAR_THICK,TOP_FRONT_BAR_HEIGHT-TOP_HEIGHT]);
//            translate([TOP_STICK_DIST/2,DEPTH-TOP_STICK_Y,HEIGHT])  /* Frank */
//            mirror([0,0,1])
//                cylinder(SCREW_HOLE_HEIGHT-TOP_HEIGHT,r=TOP_STICK_R,$fn=20);

        } 
        translate([0,0,-500])
            cube([1000,1000,1000]);
    }

    translate([-FRONT_HOLE_WIDTH_TOP/2,-SIDE_THICK/2,-FRONT_HOLE_HEIGHT_TOP])
        rect_round(FRONT_HOLE_WIDTH_TOP,2*SIDE_THICK,2*FRONT_HOLE_HEIGHT_TOP,R_CORNER_SMALL);
    }
}

module clip_holder() {
    mirror([0,1,0])
    rotate([-90,0,90]) {
        linear_extrude(height=CLIP_HOLDER_WIDTH,convexity=10)
            polygon(points=[[0,0],[0,CLIP_HOLDER_HEIGHT-CLIP_HOLDER_PROT_H-TOP_HEIGHT],[CLIP_HOLDER_PROT_W,CLIP_HOLDER_HEIGHT-TOP_HEIGHT],[CLIP_HOLDER_THICK,CLIP_HOLDER_HEIGHT-TOP_HEIGHT],[CLIP_HOLDER_THICK,0]]);
    }
}

module clip_holder_hole() {
    mirror([0,1,0])
        cube([CLIP_HOLDER_HOLE_WIDTH,CLIP_HOLDER_HOLE_DEPTH,CLIP_HOLDER_HEIGHT]);
}

module bottom_hole() {
    union() {
        translate([0,DEPTH/2,-50])
            cylinder(100,r=PCB_SUPPORT_R_HOLE, $fn=40);
        translate([0,DEPTH/2,HEIGHT+TOP_HEIGHT+0.02])
        mirror([0,0,1])
            cylinder(PCB_SUPPORT_HEIGHT_UNDER,r2=PCB_SUPPORT_R_HOLE,r1=PCB_SUPPORT_R_UNDER, $fn=40);
    }
}

module pcb_support() {
    difference() {
        translate([0,DEPTH/2,HEIGHT+TOP_HEIGHT-BOTTOM_THICK]) 
        mirror([0,0,1])
        {
            cylinder(PCB_SUPPORT_HEIGHT-BOTTOM_THICK-PCB_SUPPORT_PROT,r1=PCB_SUPPORT_R_OUTER,r2=PCB_SUPPORT_R_INNER, $fn=40);
            translate([0,0,PCB_SUPPORT_HEIGHT-BOTTOM_THICK-PCB_SUPPORT_PROT])
                cylinder(PCB_SUPPORT_PROT,r=PCB_SUPPORT_R_INNER, $fn=40);
        }
        bottom_hole();
    }
}

module body_lower_top() {
    difference() {
        translate([0,0,HEIGHT])
            body_hull();
        bottom_hole();
        translate([-CLIP_HOLDER_HOLE_WIDTH/2+(BACK_CLIP_DIST+BACK_CLIP_WIDTH)/2,DEPTH-CLIP_HOLDER_Y,CLIP_HOLDER_PROT_H])
            clip_holder_hole();
        front_hole_bottom();
    }
}

module body_lower_rest() {
    intersection() {
        difference() {
            body_help(BOTTOM_THICK);
            body_round(SIDE_PROTRUSION_BOTTOM,SIDE_THIN,SIDE_THIN,SIDE_THIN,R_CORNER_SMALL);
            front_hole_bottom();
            translate([0,DEPTH-5,0])
                cube([BACK_HOLE_WIDTH_BOTTOM/2,10,BACK_HOLE_HEIGHT_BOTTOM]);
            translate([-CLIP_HOLDER_HOLE_WIDTH/2+(BACK_CLIP_DIST+BACK_CLIP_WIDTH)/2,DEPTH-CLIP_HOLDER_Y,CLIP_HOLDER_PROT_H])
                clip_holder_hole();
            bottom_hole();
        }

        translate([0,0,-500])
            cube([1000,1000,1000]);
    }
    difference() {
        cube([FRONT_HOLE_WIDTH_BOTTOM/2+SIDE_THICK-SIDE_THIN,SIDE_THICK,HEIGHT]);
        front_hole_bottom();
    }
    bottom_front_bar();
    difference() {
        translate([CLIP_HOLDER_WIDTH/2+(BACK_CLIP_DIST+BACK_CLIP_WIDTH)/2,DEPTH-CLIP_HOLDER_Y,HEIGHT])
            clip_holder();
        translate([-CLIP_HOLDER_HOLE_WIDTH/2+(BACK_CLIP_DIST+BACK_CLIP_WIDTH)/2,DEPTH-CLIP_HOLDER_Y,HEIGHT+TOP_HEIGHT-CLIP_HOLDER_HEIGHT+CLIP_HOLDER_PROT_H])
            clip_holder_hole();
    }
    if(ADD_SUPPORT)
        translate([BACK_CLIP_WIDTH/2-0.5+(BACK_CLIP_DIST+BACK_CLIP_WIDTH)/2,DEPTH-CLIP_HOLDER_Y-EXT_WIDTH+0.5,HEIGHT-(BOTTOM_THICK-TOP_HEIGHT)])
        mirror([0,0,1])
        mirror([1,0,0])
            cube([BACK_CLIP_WIDTH-1,EXT_WIDTH,CLIP_HOLDER_HEIGHT-CLIP_HOLDER_PROT_H-TOP_HEIGHT-(BOTTOM_THICK-TOP_HEIGHT)]);
    pcb_support();
    translate([PCB_BLOCK_DIST/2,DEPTH-PCB_BLOCK_Y,HEIGHT+TOP_HEIGHT-BOTTOM_THICK-0.01])
    mirror([0,0,1])
        pcb_block();
    translate([TETRIS_DIST/2,DEPTH-SIDE_THICK+TETRIS_DEPTH/2-0.5,HEIGHT+TOP_HEIGHT-BOTTOM_THICK])
    mirror([0,0,1])
    mirror([0,1,0])
        tetris();
    translate([FRONT_CLIP_THICK+BOTTOM_FRONT_BAR_LENGTH/2,SIDE_THICK+0.7,HEIGHT+TOP_HEIGHT-BOTTOM_THICK])
    rotate([-90,0,0])
    front_clip();
    }

module body_upper() {
    body_upper_top();
    body_upper_rest();
    mirror([1,0,0]) {
        body_upper_top();
        body_upper_rest();
    }
}

module body_lower() {
    body_lower_top();
    body_lower_rest();
    mirror([1,0,0]) {
        body_lower_top();
        body_lower_rest();
    }
}

module prot_rounder(x) {
    translate([0,0,0.01])
    difference() {
        cube([x,SIDE_THICK+0.01,TOP_PROTRUSION+0.01]);
        translate([x,SIDE_THICK,-0.01])
            cylinder(TOP_PROTRUSION, r=SIDE_THICK-SIDE_THIN, $fn=20);
    }
}

module top_protrusion() {
    difference() {
        translate([0,0,-SIDE_PROTRUSION_TOP])
            difference() {
                body_round(SIDE_PROTRUSION_TOP,SIDE_THIN,SIDE_THIN,SIDE_THIN,R_CORNER);
                body_halve(SIDE_PROTRUSION_TOP+0.01,SIDE_THICK,SIDE_THICK,SIDE_THICK);
            }
        translate([0,DEPTH,-TOP_PROTRUSION])
        mirror([0,1,0])
            prot_rounder(BACK_HOLE_WIDTH_TOP/2+BACK_HOLE_OPENING_TOP+SIDE_THIN);
        translate([0,0,-TOP_PROTRUSION])
            prot_rounder(FRONT_HOLE_WIDTH_TOP/2+FRONT_HOLE_OPENING_TOP+SIDE_THIN);
    }
}

module rect_round(x,y,z,r) {
    translate([r,0,r]) 
        minkowski() {
            cube([x-2*r,y,z-2*r]);
            rotate([90,0,0])
                cylinder(0.01,r=r,$fn=20);
        }
}

module top_clip(width, height) {
    rotate([90,180,0]) {
        linear_extrude(height=width,convexity=10)
            polygon(points=[[0,0],[0,height],[BACK_CLIP_THICK,height],[BACK_CLIP_PROT_W,height-BACK_CLIP_PROT_H],[BACK_CLIP_THICK,height-BACK_CLIP_PROT_H],[BACK_CLIP_THICK,0]]);
        if(ADD_SUPPORT)
            translate([BACK_CLIP_PROT_W-EXT_WIDTH+0.2,0,0])
                cube([EXT_WIDTH,height-BACK_CLIP_PROT_H,width]);
    }
}

module front_hole_bottom() {
    linear_extrude(height=100,convexity=10)
        polygon(points=[[0,0],[FRONT_HOLE_WIDTH_BOTTOM/2,0],[FRONT_HOLE_WIDTH_BOTTOM_SMALL/2,FRONT_HOLE_DEPTH_BOTTOM],[0,FRONT_HOLE_DEPTH_BOTTOM]]);
}


module bottom_front_bar() {
    translate([BOTTOM_FRONT_BAR_LENGTH/2,FRONT_BAR_Y,HEIGHT+TOP_HEIGHT-BOTTOM_THICK+0.01]) {
        rotate([0,180,0])
        union() {
            intersection() {
                cube([BOTTOM_FRONT_BAR_LENGTH/2,FRONT_BAR_THICK, BOTTOM_FRONT_BAR_HEIGHT]);
                translate([-R_CORNER_SMALL,0,0])
                rect_round(BOTTOM_FRONT_BAR_ROUNDRECT,FRONT_BAR_THICK,BOTTOM_FRONT_BAR_HEIGHT,R_CORNER_SMALL); 
            }
            cube([BOTTOM_FRONT_BAR_LENGTH/2,FRONT_BAR_THICK, PCB_SUPPORT_HEIGHT-BOTTOM_THICK]);
        }
    }
}

module pcb_block() {
    translate([-PCB_BLOCK_WIDTH/2,0,0])
        cube([PCB_BLOCK_WIDTH,PCB_BLOCK_THICK,PCB_BLOCK_HEIGHT-BOTTOM_THICK]);

    translate([-PCB_BLOCK_THICK/2,0,0])
    mirror([0,1,0])
    rotate([90,0,90])
    linear_extrude(height=PCB_BLOCK_THICK,convexity=10)
        polygon(points=[[-PCB_BLOCK_DEPTH_LOW,0],[0,0],[0,PCB_BLOCK_HEIGHT-BOTTOM_THICK],[-PCB_BLOCK_DEPTH_HIGH,PCB_BLOCK_HEIGHT-BOTTOM_THICK]]);
}

module front_clip() {
    rotate([0,0,90]) {
        rect_round(FRONT_CLIP_HEIGHT-TOP_HEIGHT,FRONT_CLIP_THICK,FRONT_CLIP_WIDTH,R_CORNER_SMALL);
        translate([0,0,-SIDE_THICK])
        cube([HEIGHT-SIDE_PROTRUSION_BOTTOM,FRONT_CLIP_THICK,FRONT_CLIP_WIDTH+SIDE_THICK]);
    }
    translate([0,FRONT_CLIP_PROT_Z-TOP_HEIGHT,0.5])
    linear_extrude(height=FRONT_CLIP_WIDTH-1)
        polygon(points=[[0,0],[FRONT_CLIP_PROT,0],[0,FRONT_CLIP_PROT_H]]);
    if(ADD_SUPPORT)
        translate([0.8,0,0.5])
            cube([EXT_WIDTH,FRONT_CLIP_PROT_Z-TOP_HEIGHT, FRONT_CLIP_WIDTH-1]);
}

module cartridge() {
    body_upper();
    mirror([0,0,1])
        body_lower();
}

module tetris() {
    translate([-TETRIS_THICK/2,0,0]) {
        cube([TETRIS_THICK, TETRIS_DEPTH/2, HEIGHT-BOTTOM_THICK]);
        translate([0,TETRIS_DEPTH/2,0])
            cube([TETRIS_THICK, TETRIS_DEPTH/2, TETRIS_HEIGHT-BOTTOM_THICK]);
        translate([0,2*TETRIS_DEPTH/2,0])
            cube([TETRIS_THICK, TETRIS_DEPTH/2, TETRIS_HEIGHT2-BOTTOM_THICK]);
    }
}

module cartridge_explode() {
    mirror([0,0,1]) {
        body_upper();
        translate([0,-10,0])
        mirror([0,0,1])
        rotate([180,0,0])
            body_lower();
    }
}

module cut_back_clip() {
    intersection() {
        cartridge();
        translate([(BACK_CLIP_DIST+BACK_CLIP_WIDTH)/2,0,0])
            cube([0.1,200,200], center=true);
    }
}

module cut_middle() {
    intersection() {
        cartridge();
        cube([0.1,200,200], center=true);
    }
}

module cut_front() {
    intersection() {
        cartridge();
        translate([0,SIDE_THICK+FRONT_CLIP_WIDTH/2,0])
            cube([200,0.1,200], center=true);
    }
}

module extruded_polygone_chanfer(e,w,h,s1,s2){
    linear_extrude(height=e, scale=[s1,s2])
    polygon(points=[[0-w/2,0-h/2],[0-w/2,h-h/2],[w-w/2,h-h/2],[w-w/2,0-h/2]]);
}

module dip_hole(){
    translate([9,2,0]) {
        extruded_polygone_chanfer(5, 54, 15, 1.2, 1.4);
    }
    translate([9,2,-2]) {
        extruded_polygone_chanfer(5, 54, 15, 1, 1);
    }

    translate([25,0,0]) {
        extruded_polygone_chanfer(5, 17, 15, 1.74, 1.4);
    }
    translate([25,0,-2]) {
        extruded_polygone_chanfer(5, 17, 15, 1, 1);
    }
}

module rom_hole(){
    translate([0,0,0]) {
        extruded_polygone_chanfer(5, 42, 20, 1.2, 1.4);
    }
    translate([0,0,-2]) {
        extruded_polygone_chanfer(5, 42, 20, 1, 1);
    }
}


//cartridge();
//cartridge_explode();
 difference() {
    cartridge_explode();
    translate([28,51,-7]){
        rotate([0,180,0]){
            dip_hole();
        }
    }
    if(romAccess==1) {
        translate([-25,47.5,-7]){
        rotate([0,180,0]){
            rom_hole();
        }
        }
    }
    if (indentationRAMSocket==1) {
        translate([-60,15,-8]) {
            cube([120,20,5]);
        }
    }
}
//cut_back_clip();
//cut_middle();
//cut_front();
